package simulation.micro;
import java.util.Random;

import simulation.model.Config;
import simulation.query.IndexTools;
import simulation.query.SimpleIndexHit;
import simulation.query.SimpleIndexHitList;


public class InterleaveTwoTest {
	public static void test(int runs){
		double time=0.0;

		for (int j=0; j<runs;j++){
			int num = 200000;
			Random r = new Random(42);			
			int lista[] = new int[num];
			int listb[] = new int[num];
			
			
			int lasta=0;
			int lastb=0;
			for (int i=0; i<num; i+=2){
				lasta+=r.nextInt(10);
				lastb+=r.nextInt(10);
				
				lista[i] = lasta;
				lista[i+1] = (int) ( r.nextDouble() * Config.NUMBER_OF_WORDS_PER_DOCUMENT);
				listb[i] = lastb;
				listb[i+1] = (int) ( r.nextDouble() * Config.NUMBER_OF_WORDS_PER_DOCUMENT);	
			}
			
			Runtime.getRuntime().freeMemory();
			long start = System.nanoTime();
			int listc[] = new int[num*2];
			int a=0, b=0, c=0;
			while (a<num && b<num){
				if (lista[a] < listb[b]){
					listc[c]= lista[a];
					listc[c+1] = lista[a+1];
					a+=2;
					c+=2;
				} else if (lista[a] > listb[b]){
					listc[c]= lista[b];
					listc[c+1] = lista[b+1];
					b+=2;
					c+=2;
				} else {
					listc[c]= lista[a];
					listc[c+1] = lista[a+1]+lista[b+1];
					a+=2;
					b+=2;
					c+=2;
				}
			}
			
			while (a<num){
				listc[c]= lista[a];
				listc[c+1] = lista[a+1];
				a+=2;
				c+=2;
			}
			
			while (b<num){
				listc[c]= lista[b];
				listc[c+1] = lista[b+1];
				b+=2;
				c+=2;				
			}
			
			long end = System.nanoTime();
			time+=((double)(end-start))/(num);
		}
		System.out.println(time/runs / 1000000);
	}
	
	public static void main(String args[]){
		test(1000);
		test(1000);
		test(1000);
		test(1000);
		test(1000);
	}
			
}
