package simulation.model;

import java.util.*;
import java.io.*;
import simulation.*;
import simulation.query.Query;
import simulation.query.SimpleIndexHitList;
import simulation.query.SimulatedIndexHitList;
import desmoj.core.simulator.*;

public class QueryLogReader {
	private BufferedReader br;
	private HashMap<String, int[]> dict;
	private Model model;
	
	public QueryLogReader(Model model){
		this.model = model;
		dict = new HashMap<String, int[]>(31220);
		
		try {
			br = new BufferedReader(new FileReader(Config.DATAPATH + "docstat"));
			String line, tmp[];
			while ( (line = br.readLine()) != null ){
				tmp = line.split(" ");
				dict.put(tmp[0], new int[]{Integer.parseInt(tmp[1]), Integer.parseInt(tmp[2])});
			}
		} catch (FileNotFoundException fnfe){
			System.out.println("Query statistics cannot be found!");
		} catch (IOException e){
			System.out.println("Input error!");
		}
		
		try {
			br = new BufferedReader(new FileReader(Config.DATAPATH + "querylog"));
		}catch (FileNotFoundException fnfe){
			System.out.println("Query log cannot be found!");
		}
	}
	
	public int[] getNextQuery(){
		Query q = new Query(model,  "Query", false);
		try {
			String line = br.readLine();
			if (line==null) return null;
			//System.out.print(line+" [");
			String tmp[] = line.split(" ");
			int ans[] = new int[tmp.length * 2];
			for (int i=0; i<tmp.length; i++){
				int data[] = dict.get(tmp[i]);
				ans[2*i] = data[0];
				ans[2*i+1] = data[1];
				//System.out.print(((double) data[1]) / Config.NUMBER_OF_DOCUMENTS_STAT+" ");
			}
			//System.out.println("]");
			return ans;
		}catch (IOException e){
			System.out.println("Input error!");
			return null;
		}
	}
}
