package simulation.node;
import java.util.*;

import desmoj.core.advancedModellingFeatures.Res;
import desmoj.core.simulator.*;


public class ResHandler {
	private ArrayList<ProcRecord> regprocs;
	public ResHandler(){
		regprocs = new ArrayList<ProcRecord>(); 
	}
	
	public void checkWaiting(){
		for (int i=0; i<regprocs.size(); i++) {
			ProcRecord rec = regprocs.get(i);
			boolean ok=true;
			for (int j=0; j<rec.ress.length; j++){
				if ( rec.ress[j].getAvail() < rec.cnts[j]){
					ok = false;
				}
			}				
			if (ok){
				rec.process.activate(new SimTime(0.0));
				regprocs.remove(i--);
			}
		}
	}
	
	public synchronized boolean atomicResOp(SimProcess proc, Res[] ress, int[] cnts, boolean provide){
		if (provide){
			boolean ok= true;
			for (int i=0; i<ress.length; i++){
				if ( ress[i].getAvail() < cnts[i]){
					ok = false;
				}
			}
			if (ok){
				for (int i=0; i<ress.length; i++){
					ress[i].provide(cnts[i]);
				}				
				return true;
			} else {
				regprocs.add(new ProcRecord(proc,ress,cnts));
				return false;
			}
		} else {
			for (int i=0; i<ress.length; i++){
				ress[i].takeBack(cnts[i]);
			}
			checkWaiting();
			return true;
		}
	}
	
	private class ProcRecord{
		public SimProcess process;
		public Res[] ress;
		public int[] cnts;
		public ProcRecord(SimProcess sp, Res[] r, int[] c){
			process=sp;
			ress=r;
			cnts=c;
		}
	}
}
