package simulation.processes;
import simulation.model.Config;
import simulation.model.ModelS;
import simulation.node.Node;
import simulation.query.SubQuery;
import desmoj.core.simulator.*;

public abstract class SubQueryProcess extends SimProcess{
	protected SubQuery subquery;
	protected Node node;
	protected QueryProcess queryprocess;
	
	public SubQueryProcess(Model owner, String name, boolean showInTrace) {
		super(owner, name, showInTrace);
	}
	
	public SubQueryProcess(Model owner, String name, boolean showInTrace,
			 QueryProcess queryprocess, SubQuery subquery, Node node) {
		super(owner, name, showInTrace);
		this.subquery=subquery;
		this.node=node;
		this.queryprocess=queryprocess;
		if (Config.DEMO_MODE)
			((ModelS) owner).getLogWriter().logProcess(getName(), queryprocess.getName(), currentTime().getTimeValue());
	}
	
	@Override
	public void lifeCycle(){
	}

	public Node getNode() {
		return node;
	}

	public SubQuery getSubquery() {
		return subquery;
	}

}