package simulation.query;
import java.util.*;

import desmoj.core.simulator.*;

public class SubQueryResult extends Entity {
	private IndexHitList hitlist;
	
	public SubQueryResult(Model owner, String name, boolean showInTrace) {
		super(owner, name, showInTrace);
	}
	
	public SubQueryResult(Model owner, String name, boolean showInTrace, IndexHitList hitlist){
		super(owner, name, showInTrace);
		this.hitlist = hitlist;
	}
	
	public SubQueryResult(Model owner, String name, boolean showInTrace, ArrayList<IndexHitList> hitlists){
		super(owner, name, showInTrace);
		this.hitlist = IndexTools.interleaveEntries(hitlists);
	}
	
	public IndexHitList getHitList(){
		return hitlist;
	}
	
	public int getNumberOfDocuments(){
		return  (hitlist != null) ? hitlist.getNumDocs() : 0;
	}
}
